<?php 
//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
// plugin: oxyl_playlist_play.php
// author : odu
//-------------------------------------------------------------------------------------------------
// plays supported audiofiles
//-------------------------------------------------------------------------------------------------
// 031201 ........ odu         - Plugin erstellt
// 040710 ........ .fischer    - Kommentare hinzugefgt
//                             - Sonderzeichen gefixt (mit korrigiertem SpecialCharReplace & htmlspecialchars)
//                             - $pluginname eingefhrt - damit Teile universell zwischen plugins austauschbar
//                             - wenn kein Playlist-Verzeichnis angegeben wird eines im Temp Ordner angelegt und in Konfig-Datei gesichert
//                             - BACKSPACE wird zum Wechseln in bergeordnetes Verzeichnis verwendet
//                             - Ergnzung damit auch Eintrge aus Wiedergabelisten gelscht werden knnen
//                               und nicht nur ganze Wiedergabelisten
//                             - Link auf Hilfedatei korrigiert
//                             - weitere kleinere nderungen & Korrekturen
// 050327 ........ Brause      - CHANGE: an Universal Explorer angepasst
//                             - Multiusersupport hinzu
// 050918 ........ Brause      - FIX: Abspiellink verwies auf altes mp3 Plugin
//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------

  include_once('../../common/design.inc');

  $maxlines = 12;
  $mp3dispcount = 0;
  $pluginname='oxyl_file';
  $maxcharspic2 = 100; // Dateinamenlaenge in Listenmodus

  if(!isset($mode))   $mode   = 'file';
  if(!isset($mode_1)) $mode_1 = 'file';
  //vereinfachung so ist der auswertungsaufwand kleiner -> icons etc.
  if    ($mode  =="mp3")      $mode_1='mp3';
  elseif($mode  =="video")    $mode_1='video';
  elseif($mode  =="pic")      $mode_1='pic';

  if    ($mode_1=='mp3')      $mode_2='audio';
  elseif($mode_1=='video')    $mode_2='video';
  elseif($mode_1=='pic')      $mode_2='image';
  else                        $mode_2='file';

//********************************************************************************************  
//* Generate Headline
//********************************************************************************************  
  
  if (isset($ap) && (strlen($ap)>0) && (isset($plmod)) && ($plmod=='EDIT'))
    unset($plmod);
  $page['headline'] =trans($pluginname,'plugin_'.$mode.'_name').' '.trans($pluginname,'playlists');

  if (isset($plmod) && (strlen($plmod)>0))
  {
    if ($plmod=='DEL')
      $page['headline'].=' '.trans($pluginname,'title_pldel');
    if ($plmod=='EDIT')
      $page['headline'].=' '.trans($pluginname,'title_plrename');
    if ($plmod=='SHUFFLE')
      $page['headline'].=' '.trans($pluginname,'title_plshuffle');
  }
  else
  {
    $page['headline'].=' '.trans($pluginname,'title_pl');
    $plmod='PLAY';
  }

  if (! isset($ap)) $ap='';
  if (! isset($le)) $le='';
  if (! isset($st)) $st=0;
  if (! isset($fo)) $fo=' ';
  
//********************************************************************************************  
//* read playlistpath
//********************************************************************************************  

  $path=get_playlistpath();

  // falls Zeichenkette codiert wurde
  $ap = oxyl_decode($ap);


//********************************************************************************************  
//* rename_playlist if $dorename is set
//********************************************************************************************  

  if ((isset($dorename)) && (isset($oldname)) && (isset($newname)))
  {
    rename($path.'/'.$oldname.'.pls',$path.'/'.$newname.'.pls');
  }  

//********************************************************************************************  
//* Delete Playlist
//********************************************************************************************  

  if (isset($plmod) && (isset($do)) && ($plmod=='DEL') && ($do=='PL') )
  {
    if    (strpos($ap,'~_Playlist')===0)
	   $delpfad = OXYL_TEMP.'user/user_/'.substr($ap,1);
    elseif(strpos($ap,'~_'.$GLOBALS['actuser'])===0)
	   $delpfad = OXYL_TEMP.'user/user_'.$GLOBALS['actuser'].'/'.substr($ap,1);
    elseif(strpos($ap,'~_')===0)//damit nicht fremde Playlist verndert werden knnen
	   $delpfad = 'LSCHEN_VERBOTEN';
	else
	   $delpfad = $path.'/'.$ap;

    @unlink($delpfad);                                                                   //lsche gewhlte Wiedergabeliste
    unset($ap);                                                                         //lsche den aktuellen Verweis auf die gelschte Liste
  }

//********************************************************************************************  
//* read all Playlists
//********************************************************************************************  

  $pls = array();

  $pls_usr = getfiles(OXYL_TEMP.'user','pls',true,true);
//  if($GLOBALS['actuser']!='')
//     $pls_usr = array_merge($pls_usr,getfiles(OXYL_TEMP.'user/user_'.$GLOBALS['actuser'],'pls',true));

  foreach ($pls_usr as $pls_user)
  {
    $pls_user = substr($pls_user,strpos($pls_user,'/')+1);
    // STREAM CAST listen u.a. drfen nicht auftauchen
	if($mode=='file')
	{
	  if (strpos($pls_user,'_Playlist')===0 ||
	      strpos($pls_user,'_'.$GLOBALS['actuser'].'_Playlist')===0 ||
		  (preg_match('|(.*)_Playlist_audio.pls|',$pls_user) && $plmod!='DEL' && $plmod!='EDIT'))
	    $pls[]  = '~'.$pls_user;
	}
	elseif($mode=='mp3' && $plmod!='DEL' && $plmod!='EDIT')
	{
	  if (preg_match('|(.*)_Playlist_audio.pls|',$pls_user))
	    $pls[]  = '~'.$pls_user;
	}
	else
	{
	  if (strpos($pls_user,'_Playlist_'.$mode_2)===0 ||
	      strpos($pls_user,'_'.$GLOBALS['actuser'].'_Playlist_'.$mode_2)===0)
        $pls[]  = '~'.$pls_user;
	}
  }

  if($mode_1=="mp3"||$mode_1=="file")
    $pls  = array_merge($pls,getfiles($path,'pls',true));                                                         //alle Wiedergabelisten im Playlistverzeichnis erfassen

//********************************************************************************************  
//* delete playlistentry
//********************************************************************************************  

  if (isset($plmod) && (isset($do)) && ($plmod=='DEL') && ($do=='FILE') )
  {

    if    (strpos($ap,'~_Playlist')===0)
	   $delpfad = OXYL_TEMP.'user/user_/'.substr($ap,1);
    elseif(strpos($ap,'~_'.$GLOBALS['actuser'])===0)
	   $delpfad = OXYL_TEMP.'user/user_'.$GLOBALS['actuser'].'/'.substr($ap,1);
    elseif(strpos($ap,'~_')===0)//damit nicht fremde Playlist verndert werden knnen
	   $delpfad = 'LSCHEN_VERBOTEN';
	else
	   $delpfad = $path.'/'.$ap;

    $pl=array();
    if (file_exists($delpfad))                                                           //wenn im Wiedergabelistenpfad die gewhlte Wiedergabeliste existiert
    {
      $apl=file($delpfad);                                                               //diese einlesen
      $fh=fopen($delpfad,'w');                                                           //und gleich zum Schreiben ffnen
      reset($apl);                                                                            //zu ihrem ersten Eintrag springen
      foreach($apl as $p)                                                                     //und von jeden Eintrag
        if (trim($p)<>trim($fn))                                                              //berprfen ob der aktuelle Eintrag jener ist der entfernt werden soll
          fputs($fh,trim($p)."\n");                                                           //wenn nicht dann aktuellen Eintrag wieder in Datei schreiben
    fclose($fh);
    }
  }

//********************************************************************************************  
//* back navigation bar (BACK Knopf URL Erzeugung fr Basis- und Unterverzeichnisse)
//********************************************************************************************

  if (strlen($ap)==0)                                                                         //falls man gerade in der Basis des Wiedergabelisten Ordners ist
  {
    $page['nav']['back']['image']=getimghref('oxyl_nav_top.gif');                             //Pfad auf Bild fr Back Zeichen setzen
    $page['nav']['back']['href']='oxyl_file_main.php?mode='.$mode;   //Link auf Basis Ordner des oxyl_mp3 Plugins setzen
    $page['nav']['back']['fo']=$fo.' TVID="'.IR_TVID_BACKSPACE.'"';                                         //BACKSPACE Knopf auf Fernbedienung mit Wechsel in nchsthhere Ebene belegen
  }  
  else                                                                                        //ansonsten
  {
    $page['nav']['back']['image']=getimghref('oxyl_nav_top.gif');
    $page['nav']['back']['href']='oxyl_playlist_play.php?mode='.$mode; //nachdem es hier keine Ordner gibt sind nur 2 Ebenen verfgbar: Liste mit allen Wiedergabelisten oder eine Wiedergabeliste direkt, also braucht auch kein bergeordnetes Verzeichnis berechnet werden...
    $page['nav']['back']['fo']=$fo.' TVID="'.IR_TVID_BACKSPACE.'"';                                         //BACKSPACE Knopf auf Fernbedienung mit Wechsel in nchsthhere Ebene belegen
  }
  
//********************************************************************************************  
//* contents (Seiteninhalt)
//********************************************************************************************
  
  if (strlen($ap)==0)                                                                         //falls man gerade an der Basis der Wiedergabelisten ist
  {

//********************************************************************************************  
//* LINKS - RECHTS Knpfe URL Erzeugung) fr Basis
//********************************************************************************************  

    if ((count($pls)>$maxlines) && ($st>0))                                                   //wenn mehr Wiedergabelisten vorhanden als auf einer Seite erlaubt sind
    {
      if ($le=='l')                                                                           //wenn vorher gerade nach LINKS umgeblttert wurde
        $fo=' name="MyFocus"';
      else
        $fo='';

      $page['nav']['left']['image']=getimghref('oxyl_nav_left.gif');                          //Pfad auf Bild fr LINKS Button setzen
                                                                                              //Pfad bleibt gleich - nur ST wird erniedrigt und mit LE die Richtung angegeben
      $page['nav']['left']['href']='oxyl_playlist_play.php?le=l&mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&st='.(int)($st-1);
      $page['nav']['left']['fo']=$fo.' TVID="'.IR_TVID_PGUP.'"';                                          //Zuordnung auf PGUP Knopf auf Fernbedienung
    }      

    if (count($pls)>$maxlines)                                                                //falls mehr Wiedergabelisten vorhanden als auf einer Seite erlaubt sind
    {
      $page['nav']['set']['pages']=(int)($st+1);                                              //setze aktuelle Seite zur Darstellung auf Seite
      $page['nav']['set']['countpages']=(int)(((count($pls)-1)/$maxlines)+1);                 //ermittle Seitenanzahl und setze den Wert zur Darstellung auf Seite
    } 

    if ((count($pls)>$maxlines) && ((int)($st+1)<(int)(((count($pls)-1)/$maxlines)+1)))      //falls mehr Wiedergabelisten vorhanden als auf einer Seite erlaubt sind und die aktuelle Seite nicht die letzte Seite ist
    {
      if ($le=='r')                                                                           //wenn vorher gerade nach RECHTS umgeblttert wurde
        $fo=' name="MyFocus"';
      else
        $fo='';
      $page['nav']['right']['image']=getimghref('oxyl_nav_right.gif');                        //Pfad auf Bild fr RECHTS Button setzen
                                                                                              //Pfad bleibt gleich - nur ST wird erhht und mit LE die Richtung angegeben
      $page['nav']['right']['href']='oxyl_playlist_play.php?le=r&mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&st='.(int)($st+1);
      $page['nav']['right']['fo']=$fo.' TVID="'.IR_TVID_PGDN.'"';                                         //Zuordnung auf PGDN Knopf auf Fernbedienung
    }   

    $page['nav']['text']=trans($pluginname,'pl_choose');
    $page['body']['typ']='lines';

    for ($i=($st*$maxlines);($i<(($st+1)*$maxlines)) && ($i<count($pls));$i++)
    {
      $page['body']['content'][$i]['image']=getimghref('oxyl_icon_folder.gif');

      if (isset($plmod) && ($plmod=='EDIT'))
        $page['body']['content'][$i]['href']='oxyl_playlist_rename.php?mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&ap='.oxyl_encode($path).'&do=PLFILE&oldname='.str_replace('.pls','',$pls[$i]);
      else
        $page['body']['content'][$i]['href']='oxyl_playlist_play.php?mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&ap='.oxyl_encode($pls[$i]).'&do=PL';
	  if (substr($pls[$i],0,1)=='~')
	    $pls[$i]=substr($pls[$i],1);
      $page['body']['content'][$i]['text']=htmlspecialchars(str_replace('.pls','',$pls[$i]));

    }
    
  }
  else                                                                                        //wenn man in einer Wiedergabeliste ist
  {
    //content mp3-Pfade *******
    // get dirs + files
    if    (strpos($playlist,'~user_Playlist')===0)
	   $playlistpath = OXYL_TEMP.'user/user_/'.substr($playlist,1);
    elseif(strpos($playlist,'~_'.$GLOBALS['actuser'].'_Playlist')===0)
	   $playlistpath = OXYL_TEMP.'user/user_'.$GLOBALS['actuser'].'/'.substr($playlist,1);

    if    (strpos($ap,'~_Playlist')===0)
	   $pfad = OXYL_TEMP.'user/user_/'.substr($ap,1);
    elseif(strpos($ap,'~_'.$GLOBALS['actuser'])===0)
	   $pfad = OXYL_TEMP.'user/user_'.$GLOBALS['actuser'].'/'.substr($ap,1);
    elseif(strpos($ap,'~_')===0)//kruecke weil Diashow nicht userabhngig
	{  $X_User = str_replace('_Playlist_audio.pls','',str_replace('~_','',$ap));
	   $pfad = OXYL_TEMP.'user/user_'.$X_User.'/'.substr($ap,1);
	}
	else
	   $pfad = $path.'/'.$ap;

    $mp3s=file($pfad);                                                                //den Inhalt der Wiedergabeliste einlesen

    $allfiles = array();
    reset($mp3s);                                                                             //zum ersten Element der Liste springen
    foreach($mp3s as $mp3)                                                                    //und jedes Element
    {
      $allfiles[]=$mp3;                                                                       //in allfiles kopieren
      $mp3dispcount++;                                                                        //und dabei noch die Anzahl mitzhlen
    }

//********************************************************************************************  
//* LINKS - RECHTS Knpfe URL Erzeugung) fr Wiedergabelisten
//********************************************************************************************  

    if ((count($allfiles)>$maxlines) && ($st>0))                                              //falls mehr Eintrge vorhanden als auf einer Seite erlaubt sind und man nicht auf der ersten Seite ist
    {
      if ($le=='l')                                                                           //wenn vorher gerade nach LINKS umgeblttert wurde
        $fo=' name="MyFocus"';
      else
        $fo='';
      $page['nav']['left']['image']=getimghref('oxyl_nav_left.gif');                          //Pfad auf Bild fr LINKS Button setzen
                                                                                              //Pfad bleibt gleich - nur ST wird erniedrigt und mit LE die Richtung angegeben
      $page['nav']['left']['href']='oxyl_playlist_play.php?le=l&mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&st='.(int)($st-1);
      $page['nav']['left']['fo']=$fo.' TVID="'.IR_TVID_PGUP.'"';                                          //Zuordnung auf PGUP Knopf auf Fernbedienung
    }    

    if (count($allfiles)>$maxlines)                                                           //falls mehr Eintrge vorhanden als auf einer Seite erlaubt sind
    {
      $page['nav']['set']['pages']=(int)($st+1);                                              //setze aktuelle Seite zur Darstellung auf Seite
      $page['nav']['set']['countpages']=(int)((count($allfiles)/$maxlines)+1);                //ermittle Seitenanzahl und setze den Wert zur Darstellung auf Seite
    }

    if ((count($allfiles)>$maxlines) && ((int)($st+1)<(int)(((count($allfiles)-1)/$maxlines)+1)))
    {
      if ($le=='r')                                                                           //wenn vorher gerade nach RECHTS umgeblttert wurde
        $fo=' name="MyFocus"';
      else
        $fo='';
      $page['nav']['right']['image']=getimghref('oxyl_nav_right.gif');                        //Pfad auf Bild fr RECHTS Button setzen
                                                                                              //Pfad bleibt gleich - nur ST wird erhht und mit LE die Richtung angegeben
      $page['nav']['right']['href']='oxyl_playlist_play.php?le=r&mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&st='.(int)($st+1);
      $page['nav']['right']['fo']=$fo.' TVID="'.IR_TVID_PGDN.'"';                                         //Zuordnung auf PGDN Knopf auf Fernbedienung
    }  
    
    if ($mp3dispcount > 0)
    {
      $page['nav']['action'][0]['href']='oxyl_file_play.php?t=allpl&mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&ap='.oxyl_encode($pfad).'&playlist_mod='.$mode_2.'&post_port='.$GLOBALS['port'];
      $page['nav']['action'][0]['key']=IR_TVID_KEYA;
      $page['nav']['action'][0]['button']=IR_ICON_KEYA;
      $page['nav']['action'][0]['top']=true;
      if($mode=='pic')
	  {
  	    $page['nav']['action'][0]['pod']='1,0,'.OXYL_WEB.'/plugins/oxyl_file/'.$page['nav']['action'][0]['href'];
		$page['nav']['action'][0]['href']='MUTE';
	  }
      elseif($mode=='video')
  	    $page['nav']['action'][0]['vod']='playlist';
      else
  	    $page['nav']['action'][0]['aod']='playlist';
	  $page['nav']['action'][0]['target']='_new';
      $page['nav']['action'][0]['image']=getimghref('oxyl_icon_'.$mode_2.'.gif');
      $page['nav']['action'][0]['text']=htmlspecialchars(trans($pluginname,'play'));
    }

    // show dirs or files
    if (substr($ap,0,1)=='~')
	   $ap2=substr($ap,1);
	else
	   $ap2=$ap;
    $page['nav']['text']=htmlspecialchars(del_ext($ap2));
    $page['body']['typ']='lines';

    for ($i=($st*$maxlines);($i<(($st+1)*$maxlines)) && ($i<count($allfiles));$i++)           //fr alle Eintrge die auf der aktuellen Seite anzuzeigen sind
    {
      if ($ap=='')
        $page['body']['content'][$i]['image']=getimghref('oxyl_icon_folder.gif');
      else
	  {
	    
	    $ext = trim(get_ext($allfiles[$i]));
	    $pic = in_array($ext,$GLOBALS['imageextensions']) ? 'image' :
	          (in_array($ext,$GLOBALS['videoextensions']) ? 'video' :
		      (in_array($ext,$GLOBALS['audioextensions']) ? 'audio' : 'file'));

		$page['body']['content'][$i]['image']=getimghref('oxyl_icon_'.$pic.'.gif');
	  }
      if (isset($plmod) && ($plmod=='DEL'))
        $page['body']['content'][$i]['href']='oxyl_playlist_play.php?mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&ap='.oxyl_encode($ap).'&do=FILE&fn='.SpecialCharReplace(trim($allfiles[$i]));
      else
      {
        $page['body']['content'][$i]['href']='oxyl_file_play.php?t=allpl&mode='.$mode.'&mode_1='.$mode_1.'&plmod='.$plmod.'&ap='.oxyl_encode($pfad).'&startwith='.SpecialCharReplace($allfiles[$i]).'&playlist_mod='.$mode.'&post_port='.$GLOBALS['port'];
        if($mode=='pic')
		{
  	      $page['body']['content'][$i]['pod']='1,0,'.OXYL_WEB.'/plugins/oxyl_file/'.$page['body']['content'][$i]['href'];
		  $page['body']['content'][$i]['href']='MUTE';
		}
        elseif($mode=='video')
  	      $page['body']['content'][$i]['vod']='playlist';
        else
  	      $page['body']['content'][$i]['aod']='playlist';
      }
      $page['body']['content'][$i]['text']=htmlspecialchars(del_ext($allfiles[$i]));
    }
  }

//********************************************************************************************  
//* keys
//********************************************************************************************  

  if (isset($plmod) && ($plmod=='SHUFFLE'))
  {
    $page['nav']['action'][2]['href']='oxyl_playlist_play.php?plmod=DEL&mode='.$mode.'&mode_1='.$mode_1.'&ap='.oxyl_encode($ap);
    $page['nav']['action'][2]['key']=IR_TVID_KEYB;
    $page['nav']['action'][2]['button']=IR_ICON_KEYB;
    $page['nav']['action'][2]['text']=htmlspecialchars(trans($pluginname,'mode'));    
  }  
  elseif (isset($plmod) && ($plmod=='DEL'))
  {
    $page['nav']['action'][2]['href']='oxyl_playlist_play.php?plmod=EDIT&mode='.$mode.'&mode_1='.$mode_1.'&ap='.oxyl_encode($ap);
    $page['nav']['action'][2]['key']=IR_TVID_KEYB;
    $page['nav']['action'][2]['button']=IR_ICON_KEYB;
    $page['nav']['action'][2]['text']=htmlspecialchars(trans($pluginname,'mode'));    
  }    
  elseif (isset($plmod) && ($plmod=='EDIT'))
  {
    $page['nav']['action'][2]['href']='oxyl_playlist_play.php?mode='.$mode.'&mode_1='.$mode_1.'&ap='.oxyl_encode($ap);
    $page['nav']['action'][2]['key']=IR_TVID_KEYB;
    $page['nav']['action'][2]['button']=IR_ICON_KEYB;
    $page['nav']['action'][2]['text']=htmlspecialchars(trans($pluginname,'mode'));    
  }  
  else  
  {
    if (strlen($ap)<1)    
    {
      $page['nav']['action'][2]['href']='oxyl_playlist_play.php?plmod=DEL&mode='.$mode.'&mode_1='.$mode_1.'&ap='.oxyl_encode($ap);
      $page['nav']['action'][2]['key']=IR_TVID_KEYB;
      $page['nav']['action'][2]['button']=IR_ICON_KEYB;
      $page['nav']['action'][2]['text']=htmlspecialchars(trans($pluginname,'mode'));    
    }  
    else
    {
      $page['nav']['action'][2]['href']='oxyl_playlist_play.php?plmod=SHUFFLE&mode='.$mode.'&mode_1='.$mode_1.'&ap='.oxyl_encode($ap);
      $page['nav']['action'][2]['key']=IR_TVID_KEYB;
      $page['nav']['action'][2]['button']=IR_ICON_KEYB;
      $page['nav']['action'][2]['text']=htmlspecialchars(trans($pluginname,'mode'));    

    }  
  }

 
  $page['nav']['action'][3]['href']='oxyl_file_main.php';
  $page['nav']['action'][3]['key']=IR_TVID_KEYC;
  $page['nav']['action'][3]['button']=IR_ICON_KEYC;
  $page['nav']['action'][3]['text']=htmlspecialchars(trans('','back'));

  $page['help']['backhref']='oxyl_playlist_play.php?plmod='.$plmod.'&mode='.$mode.'&mode_1='.$mode_1.'&ap='.oxyl_encode($ap);
  $page['help']['href']='oxyl_mp3_pl_help';

  if(count($pls)<1){
   gen_header(true);
   if (!(isset($page['headline']))) $page['headline'] = '&nbsp;&nbsp;';
   if ($GLOBALS['showcenter']) 
	  echo '<table width=614 cellspacing=3 cellpadding=0 border=0 align="center">'."\n";
   else 
	  echo '<table width=624 cellspacing=3 cellpadding=0 border=0>'."\n";
   gen_default_title($page);      
   gen_navbar($page);  
   echo '<tr><td><table border=0><tr><td><img src="/images/pixel.gif" height="300" width="1"></td></tr></table></td></tr>';
   gen_nav_footer($page);
  }
else
  gen_full_page($page);

?>
